<?php
/*
Plugin Name: feeder-pk
Plugin URI: http://feeder.pk
Description: Feeder is a great way for Wordpress authors to send an SMS alert to their readers about a new post. Type [feeder] on any page or post to display Feeder subscribe widget.
Version: 0.6
Author: Abu Bakr Eirabie
Author URI: http://www.runbitchrun.org
*/

/*  Copyright 2009  Abu Bakr Eirabie  (email : x at runbitchrun dot com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


// Create Database User Table and Group Tables

define ('FEEDER_FULL',ABSPATH."wp-content/plugins/feeder-pk/");
define ('FEEDER',get_bloginfo('wpurl')."/wp-content/plugins/feeder-pk/");

function ro($i)
{
       require_once(FEEDER_FULL.$i.".php"); 
}

function feeder_secret_warn(){
	if(get_option('sms_secret') == ''){
		echo "<div id='feeder_secret_warning' class='updated fade'><p><strong>".__('Feeder secret key is not set.')."</strong> ".sprintf(__('You must <a href="%1$s">set your secret key</a> to make it work.'), "options-general.php?page=feeder_settings")."</p></div>";
	}
}

add_action('admin_notices', 'feeder_secret_warn');

// Require Includes & Create Database User Table and Group Tables

ro('db');
ro('options');
ro('post_publish');
ro('css');

// WP Hooks

add_action('publish_post', 'feederpost');
add_action('admin_menu', 'bf_add_pages');
add_action('admin_head', 'bf_feeder_style');
add_action('wp_head', 'bf_feeder_style');
add_action('feeder_form', 'bf_feeder_subscribe');
add_filter('the_content', 'bf_embed_form');

add_filter('query_vars', 'var_register');

function var_register($public_query_vars) {
	$public_query_vars[] = 'smsregister';
        $public_query_vars[] = 'smsmanage';
        $public_query_vars[] = 'smsconfirm';
        $public_query_vars[] = 'smsresend';
        $public_query_vars[] = 'smschange';
        $public_query_vars[] = 'smshome';
        $public_query_vars[] = 'smsretrieve';
        $public_query_vars[] = 'smsunsubscribe';
        return $public_query_vars;
}

add_action('template_redirect', 'smsregistration');
function smsregistration() {
	$register=get_query_var('smsregister');
        $manage=get_query_var('smsmanage');
        $confirm=get_query_var('smsconfirm');
        $home=get_query_var('smshome');
        $resend=get_query_var('smsresend');
        $change=get_query_var('smschange');
        $retrieve=get_query_var('smsretrieve');
        $unsubscribe=get_query_var('smsunsubscribe');
        
	if ($register) {
                ro('form_functions');
		ro('register');
		exit;
	}
        if ($manage) {
                ro('form_functions');
		ro('manage');
		exit;
	}
        if ($retrieve) {
                ro('form_functions');
		ro('manage');
		exit;
	}
        if ($home) {
                ro('form_functions');
		ro('manage');
		exit;
	}
        if ($unsubscribe) {
                ro('form_functions');
		ro('manage');
		exit;
	}
        if ($confirm) {
                ro('form_functions');
		ro('confirm');
		exit;
	}
        if ($resend) {
                ro('form_functions');
		ro('confirm');
		exit;
	}
        if ($change) {
                ro('form_functions');
		ro('confirm');
		exit;
	}
}



function bf_add_pages() 
{	 
	if (current_user_can('level_10')) 
	{
	      add_submenu_page('options-general.php', 'Feeder', 'Feeder', 8, 'feeder_settings', 'feeder_options');
	}
}

function bf_feeder_editcss()
{
       feeder_editcss();
}

function bf_feeder_style()
{
       echo "<link rel=stylesheet href='".FEEDER."style.css' type='text/css' media='all'>";
       ro('register');
}

function bf_feeder_subscribe()
{ 
        // Cell Form
	ro('form_functions'); ?>
       <div class="<? $options = get_option('bf_feeder_widget_options'); echo $options['class']; ?>">
       <div id='feederDiv'>
       <? feeder_subscribe_form('','','','') ?>
       </div>
       </div>

<? }

function bf_embed_form($content)
{
       // Embed Form
       if(strpos($content, "[feeder]"))
       {
              $part = explode("[feeder]", $content);
              if ($part[0] != '')
              {
                     echo $part[0];
              }
              
              bf_feeder_subscribe();
              
              if ($part[1] != '')
              {
                     echo $part[1];
              }
	      
       }
       else
       {
	      return $content;
       }
       
}

add_action("plugins_loaded", "bf_feeder_widget_init");


function bf_feeder_widget($args)
{
        extract($args);
        $title = get_option('sms_title');
        echo $before_widget.$before_title.$title.$after_title;
        bf_feeder_subscribe();
        echo $after_widget;
}

function bf_feeder_widget_options()
{
       $title = get_option('sms_title');
	$terms = get_option('sms_terms');
       if (!is_array($title) OR !is_array($terms)) {
	 $uptit = "Subscribe via SMS";
	 $upter = "* A verification code will be sent to your cell. Your subscription will be activated once you confirm it.";
       update_option('sms_terms', $upter);
       update_option('sms_title', $uptit);
       }
?>
       
           <p class='feeder_text'>&nbsp;</p>
              
<?
}

function bf_feeder_widget_init()
{
  register_sidebar_widget(__('Feeder'), 'bf_feeder_widget');
  register_widget_control(__('Feeder'), 'bf_feeder_widget_options');
}


?>